require_dependency "schemer/application_controller"

module Schemer
  class SurveysController < ApplicationController
    before_action :set_survey, only: [:show, :edit, :update, :destroy]

    # GET /surveys
    def index
      @surveys = Survey.all
    end

    # GET /surveys/1
    def show
    end

    # GET /surveys/new
    def new
      @survey = Survey.new
    end

    # GET /surveys/1/edit
    def edit
    end

    # POST /surveys
    def create
      @survey = Survey.new(survey_params)

      if @survey.save
        redirect_to @survey, notice: 'Survey was successfully created.'
      else
        render :new
      end
    end

    # PATCH/PUT /surveys/1
    def update
      if @survey.update(survey_params)
        redirect_to @survey, notice: 'Survey was successfully updated.'
      else
        render :edit
      end
    end

    # DELETE /surveys/1
    def destroy
      @survey.destroy
      redirect_to surveys_url, notice: 'Survey was successfully destroyed.'
    end

    private
      # Use callbacks to share common setup or constraints between actions.
      def set_survey
        @survey = Survey.find(params[:id])
      end

      # Only allow a trusted parameter "white list" through.
      def survey_params
        params.require(:survey).permit(:title, :description, :is_started, :is_complete, questions_attributes: [:id, :title, :_destroy, options_attributes: [:id, :title, :_destroy]])
      end
  end
end
